/* ESP32_MCP9700

   A GPIO34 analóg bemeneten mérjük egy MCP9700
   analóg hőmérő jelét. Az átszámolást az alábbi
   közelítő képlettel határozzuk meg (12 bites ADC
   és 3,3 V-os méréshatárt feltételezve:

   Ube = (Nadc + 80)* 1V/1239

   A képlet a 0.2 V < Ube < 2.5 V tartományban érvényes

   Arduino 1.8.15-tel tesztelve
*/

const int Analog_pin = 34;
uint32_t ADC_VALUE = 0;
uint32_t millivolts = 0;
float tempC;

void setup() {
  Serial.begin(115200);
  analogReadResolution(12);       // 12-bit felbontás
  analogSetAttenuation(ADC_11db); // Méréshatár 0-3,3 V
}

void loop() {
  ADC_VALUE = 0; mv_data = 0;
  for (int i = 0; i < 1000; i++) {
    ADC_VALUE += analogRead(Analog_pin);
  }
  Serial.print("ADC VALUE = ");
  Serial.println(ADC_VALUE / 1000);
  millivolts = (ADC_VALUE + 80000) / 1239;
  tempC = (millivolts - 500) / 10.0;
  Serial.print("Voltage = ");
  Serial.print(millivolts);
  Serial.print(" mV ");
  Serial.print("Temperature = ");
  Serial.print(tempC);
  Serial.println(" °C");
  delay(2000);
}
