/* ESP32_check_ADC_linearity

   A GPIO34 analóg bemeneten mérjük a potméterrel
   leosztott tápfeszültséget (3.3 V méréshatár és
   12 bites felbontás beállítással).
   A beállítandó feszültséget és ADC által mért
   számokat (1000 mérést átlagolva) a soros porton kiíratjuk.
   A bemenő feszültség értékét egy digitális kéziműszerrel
   határozzuk meg.

   Arduino 1.8.15-tel tesztelve
*/


const int Analog_channel_pin = 34;
uint32_t ADC_VALUE = 0;
char c;

void setup() {
  Serial.begin(115200);
  analogReadResolution(12);       // 12-bit felbontás
  analogSetAttenuation(ADC_11db); // Méréshatár 0-3,3 V
}

void loop() {
  if (Serial.available()) {
    while (Serial.available()) {
      c = Serial.read();
    }
    ADC_VALUE = 0;
    for (int i = 0; i < 1000; i++) {
      ADC_VALUE += analogRead(Analog_channel_pin);
    }
    Serial.print("ADC VALUE = ");
    Serial.println((ADC_VALUE + 500) / 1000);
  }
}
